class FiveDigits < Digits

  def self.run(num)
    new(num).in_words
  end
  
  def in_words
    num_mod(10000).zero? ? simple_ten_thous : complex_ten_thous
  end
  
  private
  
  attr_reader :num
  
  def initialize(num)
    @num = num
  end
  
  def first_two_digits
    TwoDigits.new(in_array[0,2].join.to_i).in_english
  end
  
  def rest_digits
    in_array[-3..-1].join.to_i
  end
  
  def rest
    rest_digits < 10 ? single_digits(rest_digits) : Digits.new(rest_digits).in_english
  end
  
  def simple_ten_thous
    [first_two_digits, prefix(power_of_ten)].join('-')
  end
  
  def complex_ten_thous
    [simple_ten_thous, rest].join('-')
  end
end