require 'yaml'
require 'active_support/inflector'

require 'modules/compute'
require 'modules/translate'
Dir["./lib/digits/*.rb"].each {|file| require file }

class EnglishNumber
  include Compute
  include Translate
  attr_reader :num
  
  def initialize(num)
    raise ArgumentError unless num.is_a?(Numeric)
    @num = num
  end
  
  # To get translation use #in_english method from ::Translate
  # Limit of digits can be set on constant DIGITS_LIMIT on ::Translate
  # For now gem works for up to three-digit numbers
  
end

